"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConnectCases = void 0;
const smithy_client_1 = require("@aws-sdk/smithy-client");
const BatchGetFieldCommand_1 = require("./commands/BatchGetFieldCommand");
const BatchPutFieldOptionsCommand_1 = require("./commands/BatchPutFieldOptionsCommand");
const CreateCaseCommand_1 = require("./commands/CreateCaseCommand");
const CreateDomainCommand_1 = require("./commands/CreateDomainCommand");
const CreateFieldCommand_1 = require("./commands/CreateFieldCommand");
const CreateLayoutCommand_1 = require("./commands/CreateLayoutCommand");
const CreateRelatedItemCommand_1 = require("./commands/CreateRelatedItemCommand");
const CreateTemplateCommand_1 = require("./commands/CreateTemplateCommand");
const DeleteDomainCommand_1 = require("./commands/DeleteDomainCommand");
const GetCaseCommand_1 = require("./commands/GetCaseCommand");
const GetCaseEventConfigurationCommand_1 = require("./commands/GetCaseEventConfigurationCommand");
const GetDomainCommand_1 = require("./commands/GetDomainCommand");
const GetLayoutCommand_1 = require("./commands/GetLayoutCommand");
const GetTemplateCommand_1 = require("./commands/GetTemplateCommand");
const ListCasesForContactCommand_1 = require("./commands/ListCasesForContactCommand");
const ListDomainsCommand_1 = require("./commands/ListDomainsCommand");
const ListFieldOptionsCommand_1 = require("./commands/ListFieldOptionsCommand");
const ListFieldsCommand_1 = require("./commands/ListFieldsCommand");
const ListLayoutsCommand_1 = require("./commands/ListLayoutsCommand");
const ListTagsForResourceCommand_1 = require("./commands/ListTagsForResourceCommand");
const ListTemplatesCommand_1 = require("./commands/ListTemplatesCommand");
const PutCaseEventConfigurationCommand_1 = require("./commands/PutCaseEventConfigurationCommand");
const SearchCasesCommand_1 = require("./commands/SearchCasesCommand");
const SearchRelatedItemsCommand_1 = require("./commands/SearchRelatedItemsCommand");
const TagResourceCommand_1 = require("./commands/TagResourceCommand");
const UntagResourceCommand_1 = require("./commands/UntagResourceCommand");
const UpdateCaseCommand_1 = require("./commands/UpdateCaseCommand");
const UpdateFieldCommand_1 = require("./commands/UpdateFieldCommand");
const UpdateLayoutCommand_1 = require("./commands/UpdateLayoutCommand");
const UpdateTemplateCommand_1 = require("./commands/UpdateTemplateCommand");
const ConnectCasesClient_1 = require("./ConnectCasesClient");
const commands = {
    BatchGetFieldCommand: BatchGetFieldCommand_1.BatchGetFieldCommand,
    BatchPutFieldOptionsCommand: BatchPutFieldOptionsCommand_1.BatchPutFieldOptionsCommand,
    CreateCaseCommand: CreateCaseCommand_1.CreateCaseCommand,
    CreateDomainCommand: CreateDomainCommand_1.CreateDomainCommand,
    CreateFieldCommand: CreateFieldCommand_1.CreateFieldCommand,
    CreateLayoutCommand: CreateLayoutCommand_1.CreateLayoutCommand,
    CreateRelatedItemCommand: CreateRelatedItemCommand_1.CreateRelatedItemCommand,
    CreateTemplateCommand: CreateTemplateCommand_1.CreateTemplateCommand,
    DeleteDomainCommand: DeleteDomainCommand_1.DeleteDomainCommand,
    GetCaseCommand: GetCaseCommand_1.GetCaseCommand,
    GetCaseEventConfigurationCommand: GetCaseEventConfigurationCommand_1.GetCaseEventConfigurationCommand,
    GetDomainCommand: GetDomainCommand_1.GetDomainCommand,
    GetLayoutCommand: GetLayoutCommand_1.GetLayoutCommand,
    GetTemplateCommand: GetTemplateCommand_1.GetTemplateCommand,
    ListCasesForContactCommand: ListCasesForContactCommand_1.ListCasesForContactCommand,
    ListDomainsCommand: ListDomainsCommand_1.ListDomainsCommand,
    ListFieldOptionsCommand: ListFieldOptionsCommand_1.ListFieldOptionsCommand,
    ListFieldsCommand: ListFieldsCommand_1.ListFieldsCommand,
    ListLayoutsCommand: ListLayoutsCommand_1.ListLayoutsCommand,
    ListTagsForResourceCommand: ListTagsForResourceCommand_1.ListTagsForResourceCommand,
    ListTemplatesCommand: ListTemplatesCommand_1.ListTemplatesCommand,
    PutCaseEventConfigurationCommand: PutCaseEventConfigurationCommand_1.PutCaseEventConfigurationCommand,
    SearchCasesCommand: SearchCasesCommand_1.SearchCasesCommand,
    SearchRelatedItemsCommand: SearchRelatedItemsCommand_1.SearchRelatedItemsCommand,
    TagResourceCommand: TagResourceCommand_1.TagResourceCommand,
    UntagResourceCommand: UntagResourceCommand_1.UntagResourceCommand,
    UpdateCaseCommand: UpdateCaseCommand_1.UpdateCaseCommand,
    UpdateFieldCommand: UpdateFieldCommand_1.UpdateFieldCommand,
    UpdateLayoutCommand: UpdateLayoutCommand_1.UpdateLayoutCommand,
    UpdateTemplateCommand: UpdateTemplateCommand_1.UpdateTemplateCommand,
};
class ConnectCases extends ConnectCasesClient_1.ConnectCasesClient {
}
exports.ConnectCases = ConnectCases;
(0, smithy_client_1.createAggregatedClient)(commands, ConnectCases);
