"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CaseFilter = exports.TemplateStatus = exports.LayoutContent = exports.Section = exports.FieldType = exports.FieldNamespace = exports.DomainStatus = exports.Order = exports.FieldFilter = exports.RelatedItemContent = exports.RelatedItemTypeFilter = exports.ServiceQuotaExceededException = exports.RelatedItemType = exports.RelatedItemInputContent = exports.CommentBodyTextType = exports.ValidationException = exports.ThrottlingException = exports.ResourceNotFoundException = exports.InternalServerException = exports.FieldValueUnion = exports.ConflictException = exports.AccessDeniedException = void 0;
const ConnectCasesServiceException_1 = require("./ConnectCasesServiceException");
class AccessDeniedException extends ConnectCasesServiceException_1.ConnectCasesServiceException {
    constructor(opts) {
        super({
            name: "AccessDeniedException",
            $fault: "client",
            ...opts,
        });
        this.name = "AccessDeniedException";
        this.$fault = "client";
        Object.setPrototypeOf(this, AccessDeniedException.prototype);
    }
}
exports.AccessDeniedException = AccessDeniedException;
class ConflictException extends ConnectCasesServiceException_1.ConnectCasesServiceException {
    constructor(opts) {
        super({
            name: "ConflictException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConflictException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConflictException.prototype);
    }
}
exports.ConflictException = ConflictException;
var FieldValueUnion;
(function (FieldValueUnion) {
    FieldValueUnion.visit = (value, visitor) => {
        if (value.stringValue !== undefined)
            return visitor.stringValue(value.stringValue);
        if (value.doubleValue !== undefined)
            return visitor.doubleValue(value.doubleValue);
        if (value.booleanValue !== undefined)
            return visitor.booleanValue(value.booleanValue);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(FieldValueUnion = exports.FieldValueUnion || (exports.FieldValueUnion = {}));
class InternalServerException extends ConnectCasesServiceException_1.ConnectCasesServiceException {
    constructor(opts) {
        super({
            name: "InternalServerException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServerException";
        this.$fault = "server";
        this.$retryable = {};
        Object.setPrototypeOf(this, InternalServerException.prototype);
        this.retryAfterSeconds = opts.retryAfterSeconds;
    }
}
exports.InternalServerException = InternalServerException;
class ResourceNotFoundException extends ConnectCasesServiceException_1.ConnectCasesServiceException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.resourceId = opts.resourceId;
        this.resourceType = opts.resourceType;
    }
}
exports.ResourceNotFoundException = ResourceNotFoundException;
class ThrottlingException extends ConnectCasesServiceException_1.ConnectCasesServiceException {
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottlingException";
        this.$fault = "client";
        this.$retryable = {};
        Object.setPrototypeOf(this, ThrottlingException.prototype);
    }
}
exports.ThrottlingException = ThrottlingException;
class ValidationException extends ConnectCasesServiceException_1.ConnectCasesServiceException {
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ValidationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ValidationException.prototype);
    }
}
exports.ValidationException = ValidationException;
exports.CommentBodyTextType = {
    PLAINTEXT: "Text/Plain",
};
var RelatedItemInputContent;
(function (RelatedItemInputContent) {
    RelatedItemInputContent.visit = (value, visitor) => {
        if (value.contact !== undefined)
            return visitor.contact(value.contact);
        if (value.comment !== undefined)
            return visitor.comment(value.comment);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(RelatedItemInputContent = exports.RelatedItemInputContent || (exports.RelatedItemInputContent = {}));
exports.RelatedItemType = {
    COMMENT: "Comment",
    CONTACT: "Contact",
};
class ServiceQuotaExceededException extends ConnectCasesServiceException_1.ConnectCasesServiceException {
    constructor(opts) {
        super({
            name: "ServiceQuotaExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "ServiceQuotaExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ServiceQuotaExceededException.prototype);
    }
}
exports.ServiceQuotaExceededException = ServiceQuotaExceededException;
var RelatedItemTypeFilter;
(function (RelatedItemTypeFilter) {
    RelatedItemTypeFilter.visit = (value, visitor) => {
        if (value.contact !== undefined)
            return visitor.contact(value.contact);
        if (value.comment !== undefined)
            return visitor.comment(value.comment);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(RelatedItemTypeFilter = exports.RelatedItemTypeFilter || (exports.RelatedItemTypeFilter = {}));
var RelatedItemContent;
(function (RelatedItemContent) {
    RelatedItemContent.visit = (value, visitor) => {
        if (value.contact !== undefined)
            return visitor.contact(value.contact);
        if (value.comment !== undefined)
            return visitor.comment(value.comment);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(RelatedItemContent = exports.RelatedItemContent || (exports.RelatedItemContent = {}));
var FieldFilter;
(function (FieldFilter) {
    FieldFilter.visit = (value, visitor) => {
        if (value.equalTo !== undefined)
            return visitor.equalTo(value.equalTo);
        if (value.contains !== undefined)
            return visitor.contains(value.contains);
        if (value.greaterThan !== undefined)
            return visitor.greaterThan(value.greaterThan);
        if (value.greaterThanOrEqualTo !== undefined)
            return visitor.greaterThanOrEqualTo(value.greaterThanOrEqualTo);
        if (value.lessThan !== undefined)
            return visitor.lessThan(value.lessThan);
        if (value.lessThanOrEqualTo !== undefined)
            return visitor.lessThanOrEqualTo(value.lessThanOrEqualTo);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(FieldFilter = exports.FieldFilter || (exports.FieldFilter = {}));
exports.Order = {
    ASCENDING: "Asc",
    DESCENDING: "Desc",
};
exports.DomainStatus = {
    ACTIVE: "Active",
    CREATION_FAILED: "CreationFailed",
    CREATION_IN_PROGRESS: "CreationInProgress",
};
exports.FieldNamespace = {
    CUSTOM: "Custom",
    SYSTEM: "System",
};
exports.FieldType = {
    BOOLEAN: "Boolean",
    DATE_TIME: "DateTime",
    NUMBER: "Number",
    SINGLE_SELECT: "SingleSelect",
    TEXT: "Text",
    URL: "Url",
};
var Section;
(function (Section) {
    Section.visit = (value, visitor) => {
        if (value.fieldGroup !== undefined)
            return visitor.fieldGroup(value.fieldGroup);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(Section = exports.Section || (exports.Section = {}));
var LayoutContent;
(function (LayoutContent) {
    LayoutContent.visit = (value, visitor) => {
        if (value.basic !== undefined)
            return visitor.basic(value.basic);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(LayoutContent = exports.LayoutContent || (exports.LayoutContent = {}));
exports.TemplateStatus = {
    ACTIVE: "Active",
    INACTIVE: "Inactive",
};
var CaseFilter;
(function (CaseFilter) {
    CaseFilter.visit = (value, visitor) => {
        if (value.field !== undefined)
            return visitor.field(value.field);
        if (value.not !== undefined)
            return visitor.not(value.not);
        if (value.andAll !== undefined)
            return visitor.andAll(value.andAll);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(CaseFilter = exports.CaseFilter || (exports.CaseFilter = {}));
