"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.paginateListFields = void 0;
const ListFieldsCommand_1 = require("../commands/ListFieldsCommand");
const ConnectCasesClient_1 = require("../ConnectCasesClient");
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new ListFieldsCommand_1.ListFieldsCommand(input), ...args);
};
async function* paginateListFields(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.nextToken = token;
        input["maxResults"] = config.pageSize;
        if (config.client instanceof ConnectCasesClient_1.ConnectCasesClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected ConnectCases | ConnectCasesClient");
        }
        yield page;
        const prevToken = token;
        token = page.nextToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
exports.paginateListFields = paginateListFields;
