import { createAggregatedClient } from "@aws-sdk/smithy-client";
import { BatchGetFieldCommand, } from "./commands/BatchGetFieldCommand";
import { BatchPutFieldOptionsCommand, } from "./commands/BatchPutFieldOptionsCommand";
import { CreateCaseCommand } from "./commands/CreateCaseCommand";
import { CreateDomainCommand, } from "./commands/CreateDomainCommand";
import { CreateFieldCommand } from "./commands/CreateFieldCommand";
import { CreateLayoutCommand, } from "./commands/CreateLayoutCommand";
import { CreateRelatedItemCommand, } from "./commands/CreateRelatedItemCommand";
import { CreateTemplateCommand, } from "./commands/CreateTemplateCommand";
import { DeleteDomainCommand, } from "./commands/DeleteDomainCommand";
import { GetCaseCommand } from "./commands/GetCaseCommand";
import { GetCaseEventConfigurationCommand, } from "./commands/GetCaseEventConfigurationCommand";
import { GetDomainCommand } from "./commands/GetDomainCommand";
import { GetLayoutCommand } from "./commands/GetLayoutCommand";
import { GetTemplateCommand } from "./commands/GetTemplateCommand";
import { ListCasesForContactCommand, } from "./commands/ListCasesForContactCommand";
import { ListDomainsCommand } from "./commands/ListDomainsCommand";
import { ListFieldOptionsCommand, } from "./commands/ListFieldOptionsCommand";
import { ListFieldsCommand } from "./commands/ListFieldsCommand";
import { ListLayoutsCommand } from "./commands/ListLayoutsCommand";
import { ListTagsForResourceCommand, } from "./commands/ListTagsForResourceCommand";
import { ListTemplatesCommand, } from "./commands/ListTemplatesCommand";
import { PutCaseEventConfigurationCommand, } from "./commands/PutCaseEventConfigurationCommand";
import { SearchCasesCommand } from "./commands/SearchCasesCommand";
import { SearchRelatedItemsCommand, } from "./commands/SearchRelatedItemsCommand";
import { TagResourceCommand } from "./commands/TagResourceCommand";
import { UntagResourceCommand, } from "./commands/UntagResourceCommand";
import { UpdateCaseCommand } from "./commands/UpdateCaseCommand";
import { UpdateFieldCommand } from "./commands/UpdateFieldCommand";
import { UpdateLayoutCommand, } from "./commands/UpdateLayoutCommand";
import { UpdateTemplateCommand, } from "./commands/UpdateTemplateCommand";
import { ConnectCasesClient } from "./ConnectCasesClient";
const commands = {
    BatchGetFieldCommand,
    BatchPutFieldOptionsCommand,
    CreateCaseCommand,
    CreateDomainCommand,
    CreateFieldCommand,
    CreateLayoutCommand,
    CreateRelatedItemCommand,
    CreateTemplateCommand,
    DeleteDomainCommand,
    GetCaseCommand,
    GetCaseEventConfigurationCommand,
    GetDomainCommand,
    GetLayoutCommand,
    GetTemplateCommand,
    ListCasesForContactCommand,
    ListDomainsCommand,
    ListFieldOptionsCommand,
    ListFieldsCommand,
    ListLayoutsCommand,
    ListTagsForResourceCommand,
    ListTemplatesCommand,
    PutCaseEventConfigurationCommand,
    SearchCasesCommand,
    SearchRelatedItemsCommand,
    TagResourceCommand,
    UntagResourceCommand,
    UpdateCaseCommand,
    UpdateFieldCommand,
    UpdateLayoutCommand,
    UpdateTemplateCommand,
};
export class ConnectCases extends ConnectCasesClient {
}
createAggregatedClient(commands, ConnectCases);
