import { ConnectCasesServiceException as __BaseException } from "./ConnectCasesServiceException";
export class AccessDeniedException extends __BaseException {
    constructor(opts) {
        super({
            name: "AccessDeniedException",
            $fault: "client",
            ...opts,
        });
        this.name = "AccessDeniedException";
        this.$fault = "client";
        Object.setPrototypeOf(this, AccessDeniedException.prototype);
    }
}
export class ConflictException extends __BaseException {
    constructor(opts) {
        super({
            name: "ConflictException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConflictException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConflictException.prototype);
    }
}
export var FieldValueUnion;
(function (FieldValueUnion) {
    FieldValueUnion.visit = (value, visitor) => {
        if (value.stringValue !== undefined)
            return visitor.stringValue(value.stringValue);
        if (value.doubleValue !== undefined)
            return visitor.doubleValue(value.doubleValue);
        if (value.booleanValue !== undefined)
            return visitor.booleanValue(value.booleanValue);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(FieldValueUnion || (FieldValueUnion = {}));
export class InternalServerException extends __BaseException {
    constructor(opts) {
        super({
            name: "InternalServerException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServerException";
        this.$fault = "server";
        this.$retryable = {};
        Object.setPrototypeOf(this, InternalServerException.prototype);
        this.retryAfterSeconds = opts.retryAfterSeconds;
    }
}
export class ResourceNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.resourceId = opts.resourceId;
        this.resourceType = opts.resourceType;
    }
}
export class ThrottlingException extends __BaseException {
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottlingException";
        this.$fault = "client";
        this.$retryable = {};
        Object.setPrototypeOf(this, ThrottlingException.prototype);
    }
}
export class ValidationException extends __BaseException {
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ValidationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ValidationException.prototype);
    }
}
export const CommentBodyTextType = {
    PLAINTEXT: "Text/Plain",
};
export var RelatedItemInputContent;
(function (RelatedItemInputContent) {
    RelatedItemInputContent.visit = (value, visitor) => {
        if (value.contact !== undefined)
            return visitor.contact(value.contact);
        if (value.comment !== undefined)
            return visitor.comment(value.comment);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(RelatedItemInputContent || (RelatedItemInputContent = {}));
export const RelatedItemType = {
    COMMENT: "Comment",
    CONTACT: "Contact",
};
export class ServiceQuotaExceededException extends __BaseException {
    constructor(opts) {
        super({
            name: "ServiceQuotaExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "ServiceQuotaExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ServiceQuotaExceededException.prototype);
    }
}
export var RelatedItemTypeFilter;
(function (RelatedItemTypeFilter) {
    RelatedItemTypeFilter.visit = (value, visitor) => {
        if (value.contact !== undefined)
            return visitor.contact(value.contact);
        if (value.comment !== undefined)
            return visitor.comment(value.comment);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(RelatedItemTypeFilter || (RelatedItemTypeFilter = {}));
export var RelatedItemContent;
(function (RelatedItemContent) {
    RelatedItemContent.visit = (value, visitor) => {
        if (value.contact !== undefined)
            return visitor.contact(value.contact);
        if (value.comment !== undefined)
            return visitor.comment(value.comment);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(RelatedItemContent || (RelatedItemContent = {}));
export var FieldFilter;
(function (FieldFilter) {
    FieldFilter.visit = (value, visitor) => {
        if (value.equalTo !== undefined)
            return visitor.equalTo(value.equalTo);
        if (value.contains !== undefined)
            return visitor.contains(value.contains);
        if (value.greaterThan !== undefined)
            return visitor.greaterThan(value.greaterThan);
        if (value.greaterThanOrEqualTo !== undefined)
            return visitor.greaterThanOrEqualTo(value.greaterThanOrEqualTo);
        if (value.lessThan !== undefined)
            return visitor.lessThan(value.lessThan);
        if (value.lessThanOrEqualTo !== undefined)
            return visitor.lessThanOrEqualTo(value.lessThanOrEqualTo);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(FieldFilter || (FieldFilter = {}));
export const Order = {
    ASCENDING: "Asc",
    DESCENDING: "Desc",
};
export const DomainStatus = {
    ACTIVE: "Active",
    CREATION_FAILED: "CreationFailed",
    CREATION_IN_PROGRESS: "CreationInProgress",
};
export const FieldNamespace = {
    CUSTOM: "Custom",
    SYSTEM: "System",
};
export const FieldType = {
    BOOLEAN: "Boolean",
    DATE_TIME: "DateTime",
    NUMBER: "Number",
    SINGLE_SELECT: "SingleSelect",
    TEXT: "Text",
    URL: "Url",
};
export var Section;
(function (Section) {
    Section.visit = (value, visitor) => {
        if (value.fieldGroup !== undefined)
            return visitor.fieldGroup(value.fieldGroup);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(Section || (Section = {}));
export var LayoutContent;
(function (LayoutContent) {
    LayoutContent.visit = (value, visitor) => {
        if (value.basic !== undefined)
            return visitor.basic(value.basic);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(LayoutContent || (LayoutContent = {}));
export const TemplateStatus = {
    ACTIVE: "Active",
    INACTIVE: "Inactive",
};
export var CaseFilter;
(function (CaseFilter) {
    CaseFilter.visit = (value, visitor) => {
        if (value.field !== undefined)
            return visitor.field(value.field);
        if (value.not !== undefined)
            return visitor.not(value.not);
        if (value.andAll !== undefined)
            return visitor.andAll(value.andAll);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(CaseFilter || (CaseFilter = {}));
