import { SearchRelatedItemsCommand, } from "../commands/SearchRelatedItemsCommand";
import { ConnectCasesClient } from "../ConnectCasesClient";
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new SearchRelatedItemsCommand(input), ...args);
};
export async function* paginateSearchRelatedItems(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.nextToken = token;
        input["maxResults"] = config.pageSize;
        if (config.client instanceof ConnectCasesClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected ConnectCases | ConnectCasesClient");
        }
        yield page;
        const prevToken = token;
        token = page.nextToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
