/**
 * <p>With Amazon Connect Cases, your agents can track and manage customer issues that require
 *       multiple interactions, follow-up tasks, and teams in your contact center. A case represents a
 *       customer issue. It records the issue, the steps and interactions taken to resolve the issue,
 *       and the outcome. For more information, see <a href="https://docs.aws.amazon.com/connect/latest/adminguide/cases.html">Amazon Connect Cases</a> in the
 *           <i>Amazon Connect Administrator Guide</i>.</p>
 *
 * @packageDocumentation
 */
export * from "./ConnectCasesClient";
export * from "./ConnectCases";
export * from "./commands";
export * from "./pagination";
export * from "./models";
export { ConnectCasesServiceException } from "./models/ConnectCasesServiceException";
