import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { BatchGetFieldCommandInput, BatchGetFieldCommandOutput } from "../commands/BatchGetFieldCommand";
import { BatchPutFieldOptionsCommandInput, BatchPutFieldOptionsCommandOutput } from "../commands/BatchPutFieldOptionsCommand";
import { CreateCaseCommandInput, CreateCaseCommandOutput } from "../commands/CreateCaseCommand";
import { CreateDomainCommandInput, CreateDomainCommandOutput } from "../commands/CreateDomainCommand";
import { CreateFieldCommandInput, CreateFieldCommandOutput } from "../commands/CreateFieldCommand";
import { CreateLayoutCommandInput, CreateLayoutCommandOutput } from "../commands/CreateLayoutCommand";
import { CreateRelatedItemCommandInput, CreateRelatedItemCommandOutput } from "../commands/CreateRelatedItemCommand";
import { CreateTemplateCommandInput, CreateTemplateCommandOutput } from "../commands/CreateTemplateCommand";
import { DeleteDomainCommandInput, DeleteDomainCommandOutput } from "../commands/DeleteDomainCommand";
import { GetCaseCommandInput, GetCaseCommandOutput } from "../commands/GetCaseCommand";
import { GetCaseEventConfigurationCommandInput, GetCaseEventConfigurationCommandOutput } from "../commands/GetCaseEventConfigurationCommand";
import { GetDomainCommandInput, GetDomainCommandOutput } from "../commands/GetDomainCommand";
import { GetLayoutCommandInput, GetLayoutCommandOutput } from "../commands/GetLayoutCommand";
import { GetTemplateCommandInput, GetTemplateCommandOutput } from "../commands/GetTemplateCommand";
import { ListCasesForContactCommandInput, ListCasesForContactCommandOutput } from "../commands/ListCasesForContactCommand";
import { ListDomainsCommandInput, ListDomainsCommandOutput } from "../commands/ListDomainsCommand";
import { ListFieldOptionsCommandInput, ListFieldOptionsCommandOutput } from "../commands/ListFieldOptionsCommand";
import { ListFieldsCommandInput, ListFieldsCommandOutput } from "../commands/ListFieldsCommand";
import { ListLayoutsCommandInput, ListLayoutsCommandOutput } from "../commands/ListLayoutsCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { ListTemplatesCommandInput, ListTemplatesCommandOutput } from "../commands/ListTemplatesCommand";
import { PutCaseEventConfigurationCommandInput, PutCaseEventConfigurationCommandOutput } from "../commands/PutCaseEventConfigurationCommand";
import { SearchCasesCommandInput, SearchCasesCommandOutput } from "../commands/SearchCasesCommand";
import { SearchRelatedItemsCommandInput, SearchRelatedItemsCommandOutput } from "../commands/SearchRelatedItemsCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateCaseCommandInput, UpdateCaseCommandOutput } from "../commands/UpdateCaseCommand";
import { UpdateFieldCommandInput, UpdateFieldCommandOutput } from "../commands/UpdateFieldCommand";
import { UpdateLayoutCommandInput, UpdateLayoutCommandOutput } from "../commands/UpdateLayoutCommand";
import { UpdateTemplateCommandInput, UpdateTemplateCommandOutput } from "../commands/UpdateTemplateCommand";
/**
 * serializeAws_restJson1BatchGetFieldCommand
 */
export declare const se_BatchGetFieldCommand: (input: BatchGetFieldCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1BatchPutFieldOptionsCommand
 */
export declare const se_BatchPutFieldOptionsCommand: (input: BatchPutFieldOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateCaseCommand
 */
export declare const se_CreateCaseCommand: (input: CreateCaseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateDomainCommand
 */
export declare const se_CreateDomainCommand: (input: CreateDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateFieldCommand
 */
export declare const se_CreateFieldCommand: (input: CreateFieldCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateLayoutCommand
 */
export declare const se_CreateLayoutCommand: (input: CreateLayoutCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateRelatedItemCommand
 */
export declare const se_CreateRelatedItemCommand: (input: CreateRelatedItemCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateTemplateCommand
 */
export declare const se_CreateTemplateCommand: (input: CreateTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteDomainCommand
 */
export declare const se_DeleteDomainCommand: (input: DeleteDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetCaseCommand
 */
export declare const se_GetCaseCommand: (input: GetCaseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetCaseEventConfigurationCommand
 */
export declare const se_GetCaseEventConfigurationCommand: (input: GetCaseEventConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDomainCommand
 */
export declare const se_GetDomainCommand: (input: GetDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetLayoutCommand
 */
export declare const se_GetLayoutCommand: (input: GetLayoutCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetTemplateCommand
 */
export declare const se_GetTemplateCommand: (input: GetTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListCasesForContactCommand
 */
export declare const se_ListCasesForContactCommand: (input: ListCasesForContactCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListDomainsCommand
 */
export declare const se_ListDomainsCommand: (input: ListDomainsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListFieldOptionsCommand
 */
export declare const se_ListFieldOptionsCommand: (input: ListFieldOptionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListFieldsCommand
 */
export declare const se_ListFieldsCommand: (input: ListFieldsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListLayoutsCommand
 */
export declare const se_ListLayoutsCommand: (input: ListLayoutsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListTemplatesCommand
 */
export declare const se_ListTemplatesCommand: (input: ListTemplatesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1PutCaseEventConfigurationCommand
 */
export declare const se_PutCaseEventConfigurationCommand: (input: PutCaseEventConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1SearchCasesCommand
 */
export declare const se_SearchCasesCommand: (input: SearchCasesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1SearchRelatedItemsCommand
 */
export declare const se_SearchRelatedItemsCommand: (input: SearchRelatedItemsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateCaseCommand
 */
export declare const se_UpdateCaseCommand: (input: UpdateCaseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateFieldCommand
 */
export declare const se_UpdateFieldCommand: (input: UpdateFieldCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateLayoutCommand
 */
export declare const se_UpdateLayoutCommand: (input: UpdateLayoutCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateTemplateCommand
 */
export declare const se_UpdateTemplateCommand: (input: UpdateTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_restJson1BatchGetFieldCommand
 */
export declare const de_BatchGetFieldCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetFieldCommandOutput>;
/**
 * deserializeAws_restJson1BatchPutFieldOptionsCommand
 */
export declare const de_BatchPutFieldOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchPutFieldOptionsCommandOutput>;
/**
 * deserializeAws_restJson1CreateCaseCommand
 */
export declare const de_CreateCaseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCaseCommandOutput>;
/**
 * deserializeAws_restJson1CreateDomainCommand
 */
export declare const de_CreateDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDomainCommandOutput>;
/**
 * deserializeAws_restJson1CreateFieldCommand
 */
export declare const de_CreateFieldCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateFieldCommandOutput>;
/**
 * deserializeAws_restJson1CreateLayoutCommand
 */
export declare const de_CreateLayoutCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateLayoutCommandOutput>;
/**
 * deserializeAws_restJson1CreateRelatedItemCommand
 */
export declare const de_CreateRelatedItemCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRelatedItemCommandOutput>;
/**
 * deserializeAws_restJson1CreateTemplateCommand
 */
export declare const de_CreateTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTemplateCommandOutput>;
/**
 * deserializeAws_restJson1DeleteDomainCommand
 */
export declare const de_DeleteDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDomainCommandOutput>;
/**
 * deserializeAws_restJson1GetCaseCommand
 */
export declare const de_GetCaseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCaseCommandOutput>;
/**
 * deserializeAws_restJson1GetCaseEventConfigurationCommand
 */
export declare const de_GetCaseEventConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCaseEventConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1GetDomainCommand
 */
export declare const de_GetDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDomainCommandOutput>;
/**
 * deserializeAws_restJson1GetLayoutCommand
 */
export declare const de_GetLayoutCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetLayoutCommandOutput>;
/**
 * deserializeAws_restJson1GetTemplateCommand
 */
export declare const de_GetTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTemplateCommandOutput>;
/**
 * deserializeAws_restJson1ListCasesForContactCommand
 */
export declare const de_ListCasesForContactCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListCasesForContactCommandOutput>;
/**
 * deserializeAws_restJson1ListDomainsCommand
 */
export declare const de_ListDomainsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDomainsCommandOutput>;
/**
 * deserializeAws_restJson1ListFieldOptionsCommand
 */
export declare const de_ListFieldOptionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListFieldOptionsCommandOutput>;
/**
 * deserializeAws_restJson1ListFieldsCommand
 */
export declare const de_ListFieldsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListFieldsCommandOutput>;
/**
 * deserializeAws_restJson1ListLayoutsCommand
 */
export declare const de_ListLayoutsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListLayoutsCommandOutput>;
/**
 * deserializeAws_restJson1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_restJson1ListTemplatesCommand
 */
export declare const de_ListTemplatesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTemplatesCommandOutput>;
/**
 * deserializeAws_restJson1PutCaseEventConfigurationCommand
 */
export declare const de_PutCaseEventConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutCaseEventConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1SearchCasesCommand
 */
export declare const de_SearchCasesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SearchCasesCommandOutput>;
/**
 * deserializeAws_restJson1SearchRelatedItemsCommand
 */
export declare const de_SearchRelatedItemsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SearchRelatedItemsCommandOutput>;
/**
 * deserializeAws_restJson1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_restJson1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_restJson1UpdateCaseCommand
 */
export declare const de_UpdateCaseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateCaseCommandOutput>;
/**
 * deserializeAws_restJson1UpdateFieldCommand
 */
export declare const de_UpdateFieldCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateFieldCommandOutput>;
/**
 * deserializeAws_restJson1UpdateLayoutCommand
 */
export declare const de_UpdateLayoutCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateLayoutCommandOutput>;
/**
 * deserializeAws_restJson1UpdateTemplateCommand
 */
export declare const de_UpdateTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateTemplateCommandOutput>;
