import {
  RegionInputConfig,
  RegionResolvedConfig,
} from "@aws-sdk/config-resolver";
import {
  EndpointInputConfig,
  EndpointResolvedConfig,
} from "@aws-sdk/middleware-endpoint";
import {
  HostHeaderInputConfig,
  HostHeaderResolvedConfig,
} from "@aws-sdk/middleware-host-header";
import {
  RetryInputConfig,
  RetryResolvedConfig,
} from "@aws-sdk/middleware-retry";
import {
  AwsAuthInputConfig,
  AwsAuthResolvedConfig,
} from "@aws-sdk/middleware-signing";
import {
  UserAgentInputConfig,
  UserAgentResolvedConfig,
} from "@aws-sdk/middleware-user-agent";
import {
  Client as __Client,
  DefaultsMode as __DefaultsMode,
  SmithyConfiguration as __SmithyConfiguration,
  SmithyResolvedConfiguration as __SmithyResolvedConfiguration,
} from "@aws-sdk/smithy-client";
import {
  BodyLengthCalculator as __BodyLengthCalculator,
  ChecksumConstructor as __ChecksumConstructor,
  Credentials as __Credentials,
  HashConstructor as __HashConstructor,
  HttpHandlerOptions as __HttpHandlerOptions,
  Logger as __Logger,
  Provider,
  UrlParser as __UrlParser,
  UserAgent as __UserAgent,
} from "@aws-sdk/types";
import { HttpHandler as __HttpHandler } from "@smithy/protocol-http";
import {
  Decoder as __Decoder,
  Encoder as __Encoder,
  Provider as __Provider,
  StreamCollector as __StreamCollector,
} from "@smithy/types";
import {
  BatchGetFieldCommandInput,
  BatchGetFieldCommandOutput,
} from "./commands/BatchGetFieldCommand";
import {
  BatchPutFieldOptionsCommandInput,
  BatchPutFieldOptionsCommandOutput,
} from "./commands/BatchPutFieldOptionsCommand";
import {
  CreateCaseCommandInput,
  CreateCaseCommandOutput,
} from "./commands/CreateCaseCommand";
import {
  CreateDomainCommandInput,
  CreateDomainCommandOutput,
} from "./commands/CreateDomainCommand";
import {
  CreateFieldCommandInput,
  CreateFieldCommandOutput,
} from "./commands/CreateFieldCommand";
import {
  CreateLayoutCommandInput,
  CreateLayoutCommandOutput,
} from "./commands/CreateLayoutCommand";
import {
  CreateRelatedItemCommandInput,
  CreateRelatedItemCommandOutput,
} from "./commands/CreateRelatedItemCommand";
import {
  CreateTemplateCommandInput,
  CreateTemplateCommandOutput,
} from "./commands/CreateTemplateCommand";
import {
  DeleteDomainCommandInput,
  DeleteDomainCommandOutput,
} from "./commands/DeleteDomainCommand";
import {
  GetCaseCommandInput,
  GetCaseCommandOutput,
} from "./commands/GetCaseCommand";
import {
  GetCaseEventConfigurationCommandInput,
  GetCaseEventConfigurationCommandOutput,
} from "./commands/GetCaseEventConfigurationCommand";
import {
  GetDomainCommandInput,
  GetDomainCommandOutput,
} from "./commands/GetDomainCommand";
import {
  GetLayoutCommandInput,
  GetLayoutCommandOutput,
} from "./commands/GetLayoutCommand";
import {
  GetTemplateCommandInput,
  GetTemplateCommandOutput,
} from "./commands/GetTemplateCommand";
import {
  ListCasesForContactCommandInput,
  ListCasesForContactCommandOutput,
} from "./commands/ListCasesForContactCommand";
import {
  ListDomainsCommandInput,
  ListDomainsCommandOutput,
} from "./commands/ListDomainsCommand";
import {
  ListFieldOptionsCommandInput,
  ListFieldOptionsCommandOutput,
} from "./commands/ListFieldOptionsCommand";
import {
  ListFieldsCommandInput,
  ListFieldsCommandOutput,
} from "./commands/ListFieldsCommand";
import {
  ListLayoutsCommandInput,
  ListLayoutsCommandOutput,
} from "./commands/ListLayoutsCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "./commands/ListTagsForResourceCommand";
import {
  ListTemplatesCommandInput,
  ListTemplatesCommandOutput,
} from "./commands/ListTemplatesCommand";
import {
  PutCaseEventConfigurationCommandInput,
  PutCaseEventConfigurationCommandOutput,
} from "./commands/PutCaseEventConfigurationCommand";
import {
  SearchCasesCommandInput,
  SearchCasesCommandOutput,
} from "./commands/SearchCasesCommand";
import {
  SearchRelatedItemsCommandInput,
  SearchRelatedItemsCommandOutput,
} from "./commands/SearchRelatedItemsCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "./commands/TagResourceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "./commands/UntagResourceCommand";
import {
  UpdateCaseCommandInput,
  UpdateCaseCommandOutput,
} from "./commands/UpdateCaseCommand";
import {
  UpdateFieldCommandInput,
  UpdateFieldCommandOutput,
} from "./commands/UpdateFieldCommand";
import {
  UpdateLayoutCommandInput,
  UpdateLayoutCommandOutput,
} from "./commands/UpdateLayoutCommand";
import {
  UpdateTemplateCommandInput,
  UpdateTemplateCommandOutput,
} from "./commands/UpdateTemplateCommand";
import {
  ClientInputEndpointParameters,
  ClientResolvedEndpointParameters,
  EndpointParameters,
} from "./endpoint/EndpointParameters";
export { __Client };
export type ServiceInputTypes =
  | BatchGetFieldCommandInput
  | BatchPutFieldOptionsCommandInput
  | CreateCaseCommandInput
  | CreateDomainCommandInput
  | CreateFieldCommandInput
  | CreateLayoutCommandInput
  | CreateRelatedItemCommandInput
  | CreateTemplateCommandInput
  | DeleteDomainCommandInput
  | GetCaseCommandInput
  | GetCaseEventConfigurationCommandInput
  | GetDomainCommandInput
  | GetLayoutCommandInput
  | GetTemplateCommandInput
  | ListCasesForContactCommandInput
  | ListDomainsCommandInput
  | ListFieldOptionsCommandInput
  | ListFieldsCommandInput
  | ListLayoutsCommandInput
  | ListTagsForResourceCommandInput
  | ListTemplatesCommandInput
  | PutCaseEventConfigurationCommandInput
  | SearchCasesCommandInput
  | SearchRelatedItemsCommandInput
  | TagResourceCommandInput
  | UntagResourceCommandInput
  | UpdateCaseCommandInput
  | UpdateFieldCommandInput
  | UpdateLayoutCommandInput
  | UpdateTemplateCommandInput;
export type ServiceOutputTypes =
  | BatchGetFieldCommandOutput
  | BatchPutFieldOptionsCommandOutput
  | CreateCaseCommandOutput
  | CreateDomainCommandOutput
  | CreateFieldCommandOutput
  | CreateLayoutCommandOutput
  | CreateRelatedItemCommandOutput
  | CreateTemplateCommandOutput
  | DeleteDomainCommandOutput
  | GetCaseCommandOutput
  | GetCaseEventConfigurationCommandOutput
  | GetDomainCommandOutput
  | GetLayoutCommandOutput
  | GetTemplateCommandOutput
  | ListCasesForContactCommandOutput
  | ListDomainsCommandOutput
  | ListFieldOptionsCommandOutput
  | ListFieldsCommandOutput
  | ListLayoutsCommandOutput
  | ListTagsForResourceCommandOutput
  | ListTemplatesCommandOutput
  | PutCaseEventConfigurationCommandOutput
  | SearchCasesCommandOutput
  | SearchRelatedItemsCommandOutput
  | TagResourceCommandOutput
  | UntagResourceCommandOutput
  | UpdateCaseCommandOutput
  | UpdateFieldCommandOutput
  | UpdateLayoutCommandOutput
  | UpdateTemplateCommandOutput;
export interface ClientDefaults
  extends Partial<__SmithyResolvedConfiguration<__HttpHandlerOptions>> {
  requestHandler?: __HttpHandler;
  sha256?: __ChecksumConstructor | __HashConstructor;
  urlParser?: __UrlParser;
  bodyLengthChecker?: __BodyLengthCalculator;
  streamCollector?: __StreamCollector;
  base64Decoder?: __Decoder;
  base64Encoder?: __Encoder;
  utf8Decoder?: __Decoder;
  utf8Encoder?: __Encoder;
  runtime?: string;
  disableHostPrefix?: boolean;
  serviceId?: string;
  useDualstackEndpoint?: boolean | __Provider<boolean>;
  useFipsEndpoint?: boolean | __Provider<boolean>;
  region?: string | __Provider<string>;
  credentialDefaultProvider?: (input: any) => __Provider<__Credentials>;
  defaultUserAgentProvider?: Provider<__UserAgent>;
  maxAttempts?: number | __Provider<number>;
  retryMode?: string | __Provider<string>;
  logger?: __Logger;
  defaultsMode?: __DefaultsMode | __Provider<__DefaultsMode>;
}
export type ConnectCasesClientConfigType = Partial<
  __SmithyConfiguration<__HttpHandlerOptions>
> &
  ClientDefaults &
  RegionInputConfig &
  EndpointInputConfig<EndpointParameters> &
  RetryInputConfig &
  HostHeaderInputConfig &
  AwsAuthInputConfig &
  UserAgentInputConfig &
  ClientInputEndpointParameters;
export interface ConnectCasesClientConfig
  extends ConnectCasesClientConfigType {}
export type ConnectCasesClientResolvedConfigType =
  __SmithyResolvedConfiguration<__HttpHandlerOptions> &
    Required<ClientDefaults> &
    RegionResolvedConfig &
    EndpointResolvedConfig<EndpointParameters> &
    RetryResolvedConfig &
    HostHeaderResolvedConfig &
    AwsAuthResolvedConfig &
    UserAgentResolvedConfig &
    ClientResolvedEndpointParameters;
export interface ConnectCasesClientResolvedConfig
  extends ConnectCasesClientResolvedConfigType {}
export declare class ConnectCasesClient extends __Client<
  __HttpHandlerOptions,
  ServiceInputTypes,
  ServiceOutputTypes,
  ConnectCasesClientResolvedConfig
> {
  readonly config: ConnectCasesClientResolvedConfig;
  constructor(configuration: ConnectCasesClientConfig);
  destroy(): void;
}
