import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import {
  BatchGetFieldRequest,
  BatchGetFieldResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface BatchGetFieldCommandInput extends BatchGetFieldRequest {}
export interface BatchGetFieldCommandOutput
  extends BatchGetFieldResponse,
    __MetadataBearer {}
export declare class BatchGetFieldCommand extends $Command<
  BatchGetFieldCommandInput,
  BatchGetFieldCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: BatchGetFieldCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: BatchGetFieldCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<BatchGetFieldCommandInput, BatchGetFieldCommandOutput>;
  private serialize;
  private deserialize;
}
