import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import {
  BatchPutFieldOptionsRequest,
  BatchPutFieldOptionsResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface BatchPutFieldOptionsCommandInput
  extends BatchPutFieldOptionsRequest {}
export interface BatchPutFieldOptionsCommandOutput
  extends BatchPutFieldOptionsResponse,
    __MetadataBearer {}
export declare class BatchPutFieldOptionsCommand extends $Command<
  BatchPutFieldOptionsCommandInput,
  BatchPutFieldOptionsCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: BatchPutFieldOptionsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: BatchPutFieldOptionsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    BatchPutFieldOptionsCommandInput,
    BatchPutFieldOptionsCommandOutput
  >;
  private serialize;
  private deserialize;
}
