import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { CreateFieldRequest, CreateFieldResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface CreateFieldCommandInput extends CreateFieldRequest {}
export interface CreateFieldCommandOutput
  extends CreateFieldResponse,
    __MetadataBearer {}
export declare class CreateFieldCommand extends $Command<
  CreateFieldCommandInput,
  CreateFieldCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: CreateFieldCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: CreateFieldCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<CreateFieldCommandInput, CreateFieldCommandOutput>;
  private serialize;
  private deserialize;
}
