import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { CreateLayoutRequest, CreateLayoutResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface CreateLayoutCommandInput extends CreateLayoutRequest {}
export interface CreateLayoutCommandOutput
  extends CreateLayoutResponse,
    __MetadataBearer {}
export declare class CreateLayoutCommand extends $Command<
  CreateLayoutCommandInput,
  CreateLayoutCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: CreateLayoutCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: CreateLayoutCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<CreateLayoutCommandInput, CreateLayoutCommandOutput>;
  private serialize;
  private deserialize;
}
