import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import {
  CreateRelatedItemRequest,
  CreateRelatedItemResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface CreateRelatedItemCommandInput
  extends CreateRelatedItemRequest {}
export interface CreateRelatedItemCommandOutput
  extends CreateRelatedItemResponse,
    __MetadataBearer {}
export declare class CreateRelatedItemCommand extends $Command<
  CreateRelatedItemCommandInput,
  CreateRelatedItemCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: CreateRelatedItemCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: CreateRelatedItemCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<CreateRelatedItemCommandInput, CreateRelatedItemCommandOutput>;
  private serialize;
  private deserialize;
}
