import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { GetCaseRequest, GetCaseResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface GetCaseCommandInput extends GetCaseRequest {}
export interface GetCaseCommandOutput
  extends GetCaseResponse,
    __MetadataBearer {}
export declare class GetCaseCommand extends $Command<
  GetCaseCommandInput,
  GetCaseCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: GetCaseCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetCaseCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<GetCaseCommandInput, GetCaseCommandOutput>;
  private serialize;
  private deserialize;
}
