import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import {
  GetCaseEventConfigurationRequest,
  GetCaseEventConfigurationResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface GetCaseEventConfigurationCommandInput
  extends GetCaseEventConfigurationRequest {}
export interface GetCaseEventConfigurationCommandOutput
  extends GetCaseEventConfigurationResponse,
    __MetadataBearer {}
export declare class GetCaseEventConfigurationCommand extends $Command<
  GetCaseEventConfigurationCommandInput,
  GetCaseEventConfigurationCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: GetCaseEventConfigurationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetCaseEventConfigurationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    GetCaseEventConfigurationCommandInput,
    GetCaseEventConfigurationCommandOutput
  >;
  private serialize;
  private deserialize;
}
