import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { GetDomainRequest, GetDomainResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface GetDomainCommandInput extends GetDomainRequest {}
export interface GetDomainCommandOutput
  extends GetDomainResponse,
    __MetadataBearer {}
export declare class GetDomainCommand extends $Command<
  GetDomainCommandInput,
  GetDomainCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: GetDomainCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetDomainCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<GetDomainCommandInput, GetDomainCommandOutput>;
  private serialize;
  private deserialize;
}
