import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { GetLayoutRequest, GetLayoutResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface GetLayoutCommandInput extends GetLayoutRequest {}
export interface GetLayoutCommandOutput
  extends GetLayoutResponse,
    __MetadataBearer {}
export declare class GetLayoutCommand extends $Command<
  GetLayoutCommandInput,
  GetLayoutCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: GetLayoutCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetLayoutCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<GetLayoutCommandInput, GetLayoutCommandOutput>;
  private serialize;
  private deserialize;
}
