import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import {
  ListCasesForContactRequest,
  ListCasesForContactResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListCasesForContactCommandInput
  extends ListCasesForContactRequest {}
export interface ListCasesForContactCommandOutput
  extends ListCasesForContactResponse,
    __MetadataBearer {}
export declare class ListCasesForContactCommand extends $Command<
  ListCasesForContactCommandInput,
  ListCasesForContactCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: ListCasesForContactCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListCasesForContactCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<ListCasesForContactCommandInput, ListCasesForContactCommandOutput>;
  private serialize;
  private deserialize;
}
