import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { ListDomainsRequest, ListDomainsResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListDomainsCommandInput extends ListDomainsRequest {}
export interface ListDomainsCommandOutput
  extends ListDomainsResponse,
    __MetadataBearer {}
export declare class ListDomainsCommand extends $Command<
  ListDomainsCommandInput,
  ListDomainsCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: ListDomainsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListDomainsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<ListDomainsCommandInput, ListDomainsCommandOutput>;
  private serialize;
  private deserialize;
}
