import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import {
  ListFieldOptionsRequest,
  ListFieldOptionsResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListFieldOptionsCommandInput extends ListFieldOptionsRequest {}
export interface ListFieldOptionsCommandOutput
  extends ListFieldOptionsResponse,
    __MetadataBearer {}
export declare class ListFieldOptionsCommand extends $Command<
  ListFieldOptionsCommandInput,
  ListFieldOptionsCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: ListFieldOptionsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListFieldOptionsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<ListFieldOptionsCommandInput, ListFieldOptionsCommandOutput>;
  private serialize;
  private deserialize;
}
