import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { ListFieldsRequest, ListFieldsResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListFieldsCommandInput extends ListFieldsRequest {}
export interface ListFieldsCommandOutput
  extends ListFieldsResponse,
    __MetadataBearer {}
export declare class ListFieldsCommand extends $Command<
  ListFieldsCommandInput,
  ListFieldsCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: ListFieldsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListFieldsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<ListFieldsCommandInput, ListFieldsCommandOutput>;
  private serialize;
  private deserialize;
}
