import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { ListLayoutsRequest, ListLayoutsResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListLayoutsCommandInput extends ListLayoutsRequest {}
export interface ListLayoutsCommandOutput
  extends ListLayoutsResponse,
    __MetadataBearer {}
export declare class ListLayoutsCommand extends $Command<
  ListLayoutsCommandInput,
  ListLayoutsCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: ListLayoutsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListLayoutsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<ListLayoutsCommandInput, ListLayoutsCommandOutput>;
  private serialize;
  private deserialize;
}
