import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import {
  PutCaseEventConfigurationRequest,
  PutCaseEventConfigurationResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface PutCaseEventConfigurationCommandInput
  extends PutCaseEventConfigurationRequest {}
export interface PutCaseEventConfigurationCommandOutput
  extends PutCaseEventConfigurationResponse,
    __MetadataBearer {}
export declare class PutCaseEventConfigurationCommand extends $Command<
  PutCaseEventConfigurationCommandInput,
  PutCaseEventConfigurationCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: PutCaseEventConfigurationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: PutCaseEventConfigurationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    PutCaseEventConfigurationCommandInput,
    PutCaseEventConfigurationCommandOutput
  >;
  private serialize;
  private deserialize;
}
