import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { SearchCasesRequest, SearchCasesResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface SearchCasesCommandInput extends SearchCasesRequest {}
export interface SearchCasesCommandOutput
  extends SearchCasesResponse,
    __MetadataBearer {}
export declare class SearchCasesCommand extends $Command<
  SearchCasesCommandInput,
  SearchCasesCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: SearchCasesCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: SearchCasesCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<SearchCasesCommandInput, SearchCasesCommandOutput>;
  private serialize;
  private deserialize;
}
