import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import {
  SearchRelatedItemsRequest,
  SearchRelatedItemsResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface SearchRelatedItemsCommandInput
  extends SearchRelatedItemsRequest {}
export interface SearchRelatedItemsCommandOutput
  extends SearchRelatedItemsResponse,
    __MetadataBearer {}
export declare class SearchRelatedItemsCommand extends $Command<
  SearchRelatedItemsCommandInput,
  SearchRelatedItemsCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: SearchRelatedItemsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: SearchRelatedItemsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<SearchRelatedItemsCommandInput, SearchRelatedItemsCommandOutput>;
  private serialize;
  private deserialize;
}
