import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { UpdateCaseRequest, UpdateCaseResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface UpdateCaseCommandInput extends UpdateCaseRequest {}
export interface UpdateCaseCommandOutput
  extends UpdateCaseResponse,
    __MetadataBearer {}
export declare class UpdateCaseCommand extends $Command<
  UpdateCaseCommandInput,
  UpdateCaseCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: UpdateCaseCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateCaseCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<UpdateCaseCommandInput, UpdateCaseCommandOutput>;
  private serialize;
  private deserialize;
}
