import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { UpdateFieldRequest, UpdateFieldResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface UpdateFieldCommandInput extends UpdateFieldRequest {}
export interface UpdateFieldCommandOutput
  extends UpdateFieldResponse,
    __MetadataBearer {}
export declare class UpdateFieldCommand extends $Command<
  UpdateFieldCommandInput,
  UpdateFieldCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: UpdateFieldCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateFieldCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<UpdateFieldCommandInput, UpdateFieldCommandOutput>;
  private serialize;
  private deserialize;
}
