import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ConnectCasesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ConnectCasesClient";
import { UpdateLayoutRequest, UpdateLayoutResponse } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface UpdateLayoutCommandInput extends UpdateLayoutRequest {}
export interface UpdateLayoutCommandOutput
  extends UpdateLayoutResponse,
    __MetadataBearer {}
export declare class UpdateLayoutCommand extends $Command<
  UpdateLayoutCommandInput,
  UpdateLayoutCommandOutput,
  ConnectCasesClientResolvedConfig
> {
  readonly input: UpdateLayoutCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateLayoutCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ConnectCasesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<UpdateLayoutCommandInput, UpdateLayoutCommandOutput>;
  private serialize;
  private deserialize;
}
