import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import {
  BatchGetFieldCommandInput,
  BatchGetFieldCommandOutput,
} from "../commands/BatchGetFieldCommand";
import {
  BatchPutFieldOptionsCommandInput,
  BatchPutFieldOptionsCommandOutput,
} from "../commands/BatchPutFieldOptionsCommand";
import {
  CreateCaseCommandInput,
  CreateCaseCommandOutput,
} from "../commands/CreateCaseCommand";
import {
  CreateDomainCommandInput,
  CreateDomainCommandOutput,
} from "../commands/CreateDomainCommand";
import {
  CreateFieldCommandInput,
  CreateFieldCommandOutput,
} from "../commands/CreateFieldCommand";
import {
  CreateLayoutCommandInput,
  CreateLayoutCommandOutput,
} from "../commands/CreateLayoutCommand";
import {
  CreateRelatedItemCommandInput,
  CreateRelatedItemCommandOutput,
} from "../commands/CreateRelatedItemCommand";
import {
  CreateTemplateCommandInput,
  CreateTemplateCommandOutput,
} from "../commands/CreateTemplateCommand";
import {
  DeleteDomainCommandInput,
  DeleteDomainCommandOutput,
} from "../commands/DeleteDomainCommand";
import {
  GetCaseCommandInput,
  GetCaseCommandOutput,
} from "../commands/GetCaseCommand";
import {
  GetCaseEventConfigurationCommandInput,
  GetCaseEventConfigurationCommandOutput,
} from "../commands/GetCaseEventConfigurationCommand";
import {
  GetDomainCommandInput,
  GetDomainCommandOutput,
} from "../commands/GetDomainCommand";
import {
  GetLayoutCommandInput,
  GetLayoutCommandOutput,
} from "../commands/GetLayoutCommand";
import {
  GetTemplateCommandInput,
  GetTemplateCommandOutput,
} from "../commands/GetTemplateCommand";
import {
  ListCasesForContactCommandInput,
  ListCasesForContactCommandOutput,
} from "../commands/ListCasesForContactCommand";
import {
  ListDomainsCommandInput,
  ListDomainsCommandOutput,
} from "../commands/ListDomainsCommand";
import {
  ListFieldOptionsCommandInput,
  ListFieldOptionsCommandOutput,
} from "../commands/ListFieldOptionsCommand";
import {
  ListFieldsCommandInput,
  ListFieldsCommandOutput,
} from "../commands/ListFieldsCommand";
import {
  ListLayoutsCommandInput,
  ListLayoutsCommandOutput,
} from "../commands/ListLayoutsCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "../commands/ListTagsForResourceCommand";
import {
  ListTemplatesCommandInput,
  ListTemplatesCommandOutput,
} from "../commands/ListTemplatesCommand";
import {
  PutCaseEventConfigurationCommandInput,
  PutCaseEventConfigurationCommandOutput,
} from "../commands/PutCaseEventConfigurationCommand";
import {
  SearchCasesCommandInput,
  SearchCasesCommandOutput,
} from "../commands/SearchCasesCommand";
import {
  SearchRelatedItemsCommandInput,
  SearchRelatedItemsCommandOutput,
} from "../commands/SearchRelatedItemsCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "../commands/TagResourceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "../commands/UntagResourceCommand";
import {
  UpdateCaseCommandInput,
  UpdateCaseCommandOutput,
} from "../commands/UpdateCaseCommand";
import {
  UpdateFieldCommandInput,
  UpdateFieldCommandOutput,
} from "../commands/UpdateFieldCommand";
import {
  UpdateLayoutCommandInput,
  UpdateLayoutCommandOutput,
} from "../commands/UpdateLayoutCommand";
import {
  UpdateTemplateCommandInput,
  UpdateTemplateCommandOutput,
} from "../commands/UpdateTemplateCommand";
export declare const se_BatchGetFieldCommand: (
  input: BatchGetFieldCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_BatchPutFieldOptionsCommand: (
  input: BatchPutFieldOptionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateCaseCommand: (
  input: CreateCaseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateDomainCommand: (
  input: CreateDomainCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateFieldCommand: (
  input: CreateFieldCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateLayoutCommand: (
  input: CreateLayoutCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateRelatedItemCommand: (
  input: CreateRelatedItemCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateTemplateCommand: (
  input: CreateTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteDomainCommand: (
  input: DeleteDomainCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetCaseCommand: (
  input: GetCaseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetCaseEventConfigurationCommand: (
  input: GetCaseEventConfigurationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDomainCommand: (
  input: GetDomainCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetLayoutCommand: (
  input: GetLayoutCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetTemplateCommand: (
  input: GetTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListCasesForContactCommand: (
  input: ListCasesForContactCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListDomainsCommand: (
  input: ListDomainsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListFieldOptionsCommand: (
  input: ListFieldOptionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListFieldsCommand: (
  input: ListFieldsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListLayoutsCommand: (
  input: ListLayoutsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListTagsForResourceCommand: (
  input: ListTagsForResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListTemplatesCommand: (
  input: ListTemplatesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_PutCaseEventConfigurationCommand: (
  input: PutCaseEventConfigurationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_SearchCasesCommand: (
  input: SearchCasesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_SearchRelatedItemsCommand: (
  input: SearchRelatedItemsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_TagResourceCommand: (
  input: TagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UntagResourceCommand: (
  input: UntagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateCaseCommand: (
  input: UpdateCaseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateFieldCommand: (
  input: UpdateFieldCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateLayoutCommand: (
  input: UpdateLayoutCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateTemplateCommand: (
  input: UpdateTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const de_BatchGetFieldCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<BatchGetFieldCommandOutput>;
export declare const de_BatchPutFieldOptionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<BatchPutFieldOptionsCommandOutput>;
export declare const de_CreateCaseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateCaseCommandOutput>;
export declare const de_CreateDomainCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateDomainCommandOutput>;
export declare const de_CreateFieldCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateFieldCommandOutput>;
export declare const de_CreateLayoutCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateLayoutCommandOutput>;
export declare const de_CreateRelatedItemCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateRelatedItemCommandOutput>;
export declare const de_CreateTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateTemplateCommandOutput>;
export declare const de_DeleteDomainCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteDomainCommandOutput>;
export declare const de_GetCaseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetCaseCommandOutput>;
export declare const de_GetCaseEventConfigurationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetCaseEventConfigurationCommandOutput>;
export declare const de_GetDomainCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDomainCommandOutput>;
export declare const de_GetLayoutCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetLayoutCommandOutput>;
export declare const de_GetTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetTemplateCommandOutput>;
export declare const de_ListCasesForContactCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListCasesForContactCommandOutput>;
export declare const de_ListDomainsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListDomainsCommandOutput>;
export declare const de_ListFieldOptionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListFieldOptionsCommandOutput>;
export declare const de_ListFieldsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListFieldsCommandOutput>;
export declare const de_ListLayoutsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListLayoutsCommandOutput>;
export declare const de_ListTagsForResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListTagsForResourceCommandOutput>;
export declare const de_ListTemplatesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListTemplatesCommandOutput>;
export declare const de_PutCaseEventConfigurationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutCaseEventConfigurationCommandOutput>;
export declare const de_SearchCasesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SearchCasesCommandOutput>;
export declare const de_SearchRelatedItemsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SearchRelatedItemsCommandOutput>;
export declare const de_TagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TagResourceCommandOutput>;
export declare const de_UntagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UntagResourceCommandOutput>;
export declare const de_UpdateCaseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateCaseCommandOutput>;
export declare const de_UpdateFieldCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateFieldCommandOutput>;
export declare const de_UpdateLayoutCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateLayoutCommandOutput>;
export declare const de_UpdateTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateTemplateCommandOutput>;
